// **************************************************************************************
// el Comandante                                                    guerilla.bplaced.net
// --------------------------------------------------------------------------------------
// Information:
// WT32-SC01 Touchscreen And Read Pixel Test
// Reading pixel from TFT using standard HSPI isn't working with TFT_eSPI or LovyanGFX
// --------------------------------------------------------------------------------------
// Used Libraries:
// TFT_eSPI --> https://github.com/Bodmer/TFT_eSPI
// **************************************************************************************

#include <TFT_eSPI.h>                                     // TFT_espi library
TFT_eSPI tft          = TFT_eSPI();

// FT6206, FT6336U - touchscreen library                  // modified -> Wire.begin(18, 19)
#include "Adafruit_FT6206.h"
Adafruit_FT6206 ts = Adafruit_FT6206();

// Vars
uint32_t      x, y;                                       // touch point
uint32_t      xOld, yOld;                                 // old touch point
uint16_t*     buf [100];                                  // buffer, should be calculated


void setup(void)
{
  ts.begin(40);                                           // adafruit touch
  tft.init();                                             // TFT_eSPI
  digitalWrite(TFT_BL, 0);                                // switch backlight off
  tft.setRotation(3);                                     // set desired rotation
  tft.fillScreen(0x07FF);
  tft.setTextDatum(TL_DATUM);
  tft.setTextColor(0x0000, 0x07FF);
  tft.setFreeFont(&FreeSans9pt7b);
  tft.setCursor(8, 16);
  tft.print("WT32-SC01 TOUCH + TFT READ TEST");
  tft.setCursor(344, 16);
  tft.print("Touch:");
  tft.setCursor(8, 32);
  tft.print("COPY OF TOUCH RECTANGLE:");
  tft.setCursor(344, 32);
  tft.print("Should be RED");
  digitalWrite(TFT_BL, 1);                                // switch backlight on
}


void loop()
{
  if (ts.touched())
  {
    TS_Point p = ts.getPoint();
    y = p.x;                                              // adjust touch point for rotation = 3
    x = 479 - p.y;
    if (x >= 4 && x <= 476 && y >= 52 && y <= 316)
    {
      tft.fillRect(300, 24, 8, 8, 0x07FF);                // clear copy of touch rectangle
      tft.fillRect(xOld-4, yOld-4, 8, 8, 0x07FF);         // clear old touch rectangle
      tft.fillRect(x-4, y-4, 8, 8, 0xF800);               // draw touch rectangle
      tft.setCursor(404, 16);
      tft.fillRect(404, 4, 76, 16, 0x07FF);               // clear touch point values area
      tft.printf("%03d  %03d", x, y);                     // print touch point values
      tft.readRect(x-4, y-4, 8, 8, (uint16_t*)buf);       // copy red touch rectangle from TFT
      tft.pushImage(300, 24, 8, 8, (uint16_t*)buf);       // push red touch rectangle to TFT
      xOld = x;                                           // save current touch point
      yOld = y;
    }
  }
}
